fixup initial faiserver bootstrap & small bugs
[automated-distro-installer] / pxe-server
index 4d18ccb742dcad33e9d9691372a0e711e4ac4ef8..1f75adb61ebb3a443ae7a2e4e7029adc3a728991 100755 (executable)
-#!/bin/bash -x
+#!/bin/bash
+# Copyright (C) 2016 Ian Kelling
+
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License
+# as published by the Free Software Foundation; either version 2
+# of the License, or (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 
 # Setup dhcp server to point to tftp server,
 # and depending on the type, setup the tftp server.
 
-# usage: $0 [TYPE]
-# default distro is the base debian/fedora type. others are fai &  arch
+# usage: $0 TYPE
+# default distro is the base debian/fedora type. others are fai & arch.
+# for no pxe server, use a no-op like : or true.
 
 set -eE -o pipefail
-trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?"' ERR
+trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
+
+
+usage() {
+    cat <<EOF
+Usage: ${0##*/} [OPTIONS] TYPE [HOST]
+One line description
+
+TYPE is one of arch, plain, fai, or : for no pxe server.
+HOST makes the pxe server only for that specific host
+
+-h|--help  Print help and exit
+--         Subsequent arguments are never treated as options
+-p         Persist. Otherwise, wait for dhcp acks then remove.
+-r         Don't redeploy fai config.
+-a         Wait for 2 dhcp acks instead of the default 3. Some distros
+           do 2, some do 3.
+EOF
+    exit $1
+}
+
+##### begin command line parsing ########
+
+persist=false
+args=()
+redep=true
+acks=3
+while [[ $1 ]]; do
+    case $1 in
+        --) shift; break ;;
+        -h|--help) usage ;;
+        -r) redep=false; shift ;;
+        -p) persist=true; shift ;;
+        -a) acks=2; shift ;;
+        *) args+=("$1"); shift ;;
+    esac
+done
+args+=("$@")
+
 
-action=${1:-default}
+read type host <<<"${args[@]}"
+
+if [[ ! $type ]]; then
+    echo "$0: error: exptected 1 argument of type"
+    usage 1
+fi
+
+if [[ $host ]]; then
+    host_tag="tag:$host,"
+fi
+
+case $type in
+    :|true) persist=true ;;
+    arch) acks=2 ;;
+esac
+
+##### end command line parsing ########
+
+sv() {
+    echo "$@"
+    "$@"
+}
 
 arch() {
-    default
-    cat <<'EOF'
+    cat <<EOF
 dhcp-option-force=209,boot/syslinux/archiso.cfg
 dhcp-option-force=210,/arch/
-dhcp-boot=/arch/boot/syslinux/lpxelinux.0
+dhcp-boot=${host_tag}/arch/boot/syslinux/lpxelinux.0
 EOF
 }
 
-default() {
-    cat <<'EOF'
-enable-tftp
-tftp-root=/mnt/usb/tftpboot
-dhcp-boot=pxelinux.0
+plain() {
+    # if arch was used before, this additionally needs
+    # the tftp link in /mnt/usb to be changed.
+    cat <<EOF
+dhcp-boot=${host_tag}pxelinux.0
 EOF
 }
 
 fai() {
-    cat <<'EOF'
-dhcp-boot=fai/pxelinux.0,faiserver.lan,faiserver.lan
+    cat <<EOF
+$set_host_tag
+dhcp-boot=${host_tag}fai/pxelinux.0,faiserver.lan,faiserver.lan
 EOF
 }
 
+ack-wait() {
+    wait_count=$1
+    if [[ $host ]]; then
+        host_regex=" $host"
+    fi
+    regex=".*DHCPACK.*$host_regex$"
+    i=0
+    tmp=$(mktemp)
+    while (( i != wait_count )) && read line; do
+        if [[ $line =~ $regex ]]; then
+            i=$((i+1))
+            echo $line
+        fi
+    done < <(ssh wrt logread -f)
+    sv sleep 5
+}
+
+set-pxe() {
+    ${1:-$type} | ssh wrt "cedit pxe-server /etc/dnsmasq.conf || /etc/init.d/dnsmasq restart
+if [[ $type == arch ]]; then arch-pxe-mount; fi"
+}
+
+set-pxe
+
+if [[ $type == fai ]]; then
+    if $redep; then
+        fai-redep
+    fi
+    faiserver-enable
+fi
 
-$action | ssh wrt "cedit pxe-server /etc/dnsmasq.conf || /etc/init.d/dnsmasq restart
-if [[ $action == arch ]]; then arch-pxe-mount; fi"
+if ! $persist; then
+    # fai's debian jessie 8.5ish does 2 dhcp requests when booting,
+    # roughly 4 seconds apart. Earlier
+    # versions did just 1. Now testing on a vm, it does 1.
+    # bleh.
+    echo "waiting for $acks dhcp acks then disabling pxe"
+    ack-wait $acks
+    set-pxe :
+    if [[ $type == fai ]]; then
+        # fai server can contain sensitive info, so turn it off
+        # when it's not in use.
+        echo "waiting for 1 dhcp ack then disabling fai server"
+        ack-wait 1
+        faiserver-disable
+    fi
+fi